n, q, k = map(int, input().split())
permutation = list(map(int, input().split()))
priorities = [0] * n
for _ in range(q):
   l, r = map(int, input().split())
   for i in range(l - 1, r):
       priorities[i] += permutation[i - l + 1]
sorted_priorities = sorted(enumerate(priorities), key=lambda x: x[1])
result = sorted_priorities[k - 1][0] + 1
print(result)